﻿
// ESA Šakvice selected points and point groups:

var pointGroup1 = new PointGroup { Name = "1", Points = new[] { new Point { Name = "1" } } };
var pointGroup2_3 = new PointGroup { Name = "2/3", Points = new[] { new Point { Name = "2" }, new Point { Name = "3" } } };
var pointGroup4 = new PointGroup { Name = "4", Points = new[] { new Point { Name = "4" } } };
var pointGroup5_7 = new PointGroup { Name = "5/7", Points = new[] { new Point { Name = "5" }, new Point { Name = "7" } } };
var pointGroup6_9 = new PointGroup { Name = "6/9", Points = new[] { new Point { Name = "6" }, new Point { Name = "9" } } };
var pointGroup8_11 = new PointGroup { Name = "8/11", Points = new[] { new Point { Name = "8" }, new Point { Name = "11" } } };
var pointGroup10_NVk1 = new PointGroup { Name = "10/NVk1", Points = new[] { new Point { Name = "10/NVk1", Drives = new[] { new MockPointDrive { Name = "10" }, new MockPointDrive { Name = "NVk1" } } } } };
var pointGroup12_Vk1 = new PointGroup { Name = "12/Vk1", Points = new[] { new Point { Name = "12/Vk1", Drives = new[] { new MockPointDrive { Name = "12" }, new MockPointDrive { Name = "Vk1" } } } } };

var allPointGroups = new PointGroup[] { pointGroup1, pointGroup2_3, pointGroup4, pointGroup5_7, pointGroup6_9, pointGroup8_11, pointGroup10_NVk1, pointGroup12_Vk1 };

Array.ForEach(allPointGroups,
	pg => Array.ForEach(pg.Points,
		p => {
			if (p.Drives.Length == 0) {
				p.Drives = new[] { new MockPointDrive { Name = p.Name, Point = p } };
			} else {
				Array.ForEach(p.Drives, d => d.Point = p);
			}
		}
	)
);

// ESA Šakvice selected TVP sections:

var section3aK = new TvpSection { Name = "3aK" };
var sectionV11 = new TvpSection { Name = "V11", PointGroups = new[] { pointGroup8_11 } };
var section3K = new TvpSection { Name = "3K" };

var section1LK = new TvpSection { Name = "1LK" };
var sectionV2 = new TvpSection { Name = "V2", PointGroups = new[] { pointGroup2_3 } };
var sectionV7_8 = new TvpSection { Name = "V7-8", PointGroups = new[] { pointGroup5_7, pointGroup8_11 } };
var section1K = new TvpSection { Name = "1K" };

var sectionV3_4 = new TvpSection { Name = "V2-3", PointGroups = new[] { pointGroup2_3, pointGroup4 } };
var sectionV5_6 = new TvpSection { Name = "V5-6", PointGroups = new[] { pointGroup5_7, pointGroup6_9 } };

var section2aK = new TvpSection { Name = "2aK" };

var sectionHLK = new TvpSection { Name = "HLK" };
var sectionV1 = new TvpSection { Name = "V1", PointGroups = new[] { pointGroup1 } };
var section4aK = new TvpSection { Name = "4aK" };
var sectionV9_10 = new TvpSection { Name = "V9-10", PointGroups = new[] { pointGroup6_9, pointGroup10_NVk1 } };
var section4K = new TvpSection { Name = "4K" };

var sectionV10M = new TvpSection { Name = "V10M", PointGroups = new[] { pointGroup10_NVk1 } };

var debugAllSections = new TvpSection?[] {
	section3aK, sectionV11, section3K, null,
	section1LK, sectionV2, sectionV7_8, section1K, null,
	sectionV3_4, sectionV5_6, null,
	section2aK, null,
	sectionHLK, sectionV1, section4aK, sectionV9_10, section4K, null,
	sectionV10M, null
};

// ESA Šakvice selected signals:

var signal1L = new Signal { Name = "1L" };
var signalHL = new Signal { Name = "HL" };

// ESA Šakvice selected routes:
//  1: main route: HL -> 4K
//  5: main route: HL -> 3K
// 11: main route: 1L -> 4K
// 13: main route: 1L -> 1K
// 32: main route: 1S -> 4bK	(NOT IMPLEMENTED YET)
// 43: main route: S3 -> T5		(NOT IMPLEMENTED YET)

var route1 = new Route {
	Id = 1,
	Type = RouteType.Main,
	EntrySignal = signalHL,
	RequiredPointPositions = new RequiredPointPosition[] {
		new() { PointGroup = pointGroup1, Position = PointPosition.Normal },
		new() { PointGroup = pointGroup6_9, Position = PointPosition.Normal },
		new() { PointGroup = pointGroup10_NVk1, Position = PointPosition.Normal }
	},
	FlankProtectionPointPositions = new RequiredPointPosition[] {
		new() { PointGroup = pointGroup12_Vk1, Position = PointPosition.Normal },
	},
	SectionsInRoute = new[] { sectionHLK, sectionV1, section4aK, sectionV9_10, section4K },
	SectionsRequiredVacant = new[] { sectionV10M }
};

var route5 = new Route {
	Id = 5,
	Type = RouteType.Main,
	EntrySignal = signalHL,
	RequiredPointPositions = new RequiredPointPosition[] {
		new() { PointGroup = pointGroup1, Position = PointPosition.Reverse },
		new() { PointGroup = pointGroup4, Position = PointPosition.Reverse },
		new() { PointGroup = pointGroup5_7, Position = PointPosition.Reverse },
		new() { PointGroup = pointGroup8_11, Position = PointPosition.Reverse },
	},
	FlankProtectionPointPositions = new RequiredPointPosition[] {
		new() { PointGroup = pointGroup2_3, Position = PointPosition.Normal },
		new() { PointGroup = pointGroup6_9, Position = PointPosition.Normal },
	},
	SectionsInRoute = new[] { sectionHLK, sectionV1, section2aK, sectionV3_4, sectionV5_6, sectionV7_8, sectionV11, section3K },
	SectionsRequiredVacant = new[] { section3aK }
};

var route11 = new Route {
	Id = 11,
	Type = RouteType.Main,
	EntrySignal = signal1L,
	RequiredPointPositions = new RequiredPointPosition[] {
		new() { PointGroup = pointGroup2_3, Position = PointPosition.Reverse },
		new() { PointGroup = pointGroup4, Position = PointPosition.Normal },
		new() { PointGroup = pointGroup5_7, Position = PointPosition.Normal },
		new() { PointGroup = pointGroup6_9, Position = PointPosition.Reverse },
		new() { PointGroup = pointGroup10_NVk1, Position = PointPosition.Normal },
	},
	FlankProtectionPointPositions = new RequiredPointPosition[] {
		new() { PointGroup = pointGroup8_11, Position = PointPosition.Normal },
		new() { PointGroup = pointGroup12_Vk1, Position = PointPosition.Normal }
	},
	SectionsInRoute = new TvpSection[] { section1LK, sectionV2, sectionV3_4, sectionV5_6, sectionV9_10, section4K },
	SectionsRequiredVacant = new[] { sectionV10M }
};

var route13 = new Route {
	Id = 13,
	Type = RouteType.Main,
	EntrySignal = signal1L,
	RequiredPointPositions = new RequiredPointPosition[] {
		new() { PointGroup = pointGroup2_3, Position = PointPosition.Normal },
		new() { PointGroup = pointGroup5_7, Position = PointPosition.Normal },
		new() { PointGroup = pointGroup8_11, Position = PointPosition.Normal }
	},
	SectionsInRoute = new TvpSection[] { section1LK, sectionV2, sectionV7_8, section1K },
};

var interlockingTable = new InterlockingTable { Routes = new[] { route1, route5, route11, route13 } };

// Initialize mock field objects:

var allMockDrives = allPointGroups.SelectMany(pg => pg.Points.SelectMany(p => p.Drives)).Cast<MockPointDrive>().ToArray();

var mockMessenger = new MockFieldObjectMessenger(allMockDrives);

CoroutineScheduler.Current.Messenger = mockMessenger;
CoroutineScheduler.Current.Enqueue(mockMessenger.GetMotorRunningCoroutine(), CoroutinePriority.PostDriver);

// Initialize simulation:

var dumper = new DebugStateDumper {
	Points = allPointGroups.SelectMany(pg => pg.Points).ToArray(),
	TvpSections = debugAllSections,
	Scheduler = CoroutineScheduler.Current,
	Messenger = mockMessenger
};
CoroutineScheduler.Current.Enqueue(dumper.GetPeriodicDumpingCoroutine(), CoroutinePriority.Last);

var input = new DebugInput { 
	ControlledRoutes = interlockingTable.Routes,
	ControlledPointGroups = new[] { pointGroup1, pointGroup2_3, pointGroup10_NVk1 }
};
CoroutineScheduler.Current.Enqueue(input.GetCoroutine(), CoroutinePriority.PreDriver);

// Main loop
CoroutineScheduler.Current.Run();
